#
# ZAnnot.py - Zope Annotation Server
#
# Code by Brent Hendricks
#
# (C) 2002 Brent Hendricks - licensed under the terms of the
# GNU General Public License (GPL).  See LICENSE.txt for details

#
# This is a PythonScript function that process user requests
# It's implemented as a PythonScript so that it runs as restricted code

# user request
method = context.REQUEST['REQUEST_METHOD']
# call appropriate routines
if method=="GET" and context.REQUEST.has_key('w3c_annotates'):
    target = context.REQUEST['w3c_annotates']
    try:
        replyTree = context.REQUEST.form['w3c_replyTree']
    except KeyError:
        replyTree = None
    objs = context.queryAnnotation(target, replyTree)
    return context.annotationRDF(annotations = objs)
elif method=="POST":
    # New annotation or update old one
    content = str(context.REQUEST['BODY'])
    # FIXME: we should make sure the body exists
    query_string = context.REQUEST['QUERY_STRING']
    if query_string:
        for query in query_string.split('&'):
            (id, val) = query.split('=')
            if id == "replace_source":
                child_id = val.split('/')[-1]
                try:
                    annotation = context[child_id]
                except KeyError:
                    raise "Bad Request", "No such annotation: %s" % child_id
                else:
                    return annotation.update(content)
    # If 'replace_source' isn't in the query string, just add the annotation
    return context.addAnnotation(content)
# Update (PUT /annot/annotASDFASDF) - no client implements this yet
#elif method="PUT"
#    if child_id.startswith(context.prefix):
#        return context.updateAnnotation(child_id, content)
#else:
#    return Folder.__getattr__('index_html')
